diff -uwr source/scripts/engine_game.cpp 4.0/source/scripts/engine_game.cpp
--- source/scripts/engine_game.cpp	2011-08-12 06:39:30.000000000 +0800
+++ 4.0/source/scripts/engine_game.cpp	2011-10-22 19:44:00.545898400 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Global ingame classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -24,6 +23,7 @@
 #include "CombatManager.h"
 #include "VehicleFactoryGameObj.h"
 #include "VehicleFactoryGameObjDef.h"
+#include "HarvesterClass.h"
 REF_DEF2(CombatManager::IAmServer, bool, 0x00855EC8, 0x008550B0);
 RENEGADE_FUNCTION
 void *Game_Mode_Find(const char *)
@@ -35,9 +35,6 @@
 RENEGADE_FUNCTION
 void BaseControllerClass::On_Vehicle_Generated(VehicleGameObj* vehicle)
 AT2(0x006EEF00,0x006EE4C0);
-RENEGADE_FUNCTION
-VehicleGameObj *BaseControllerClass::Get_Harvester_Vehicle()
-AT2(0x006EFD60,0x006EF320);
 #endif
 RENEGADE_FUNCTION
 cGameData SCRIPTS_API *The_Game()
@@ -48,6 +45,11 @@
 RENEGADE_FUNCTION
 void BaseControllerClass::Power_Base(bool Power)
 AT2(0x006EF310,0x006EE8D0);
+VehicleGameObj *BaseControllerClass::Get_Harvester_Vehicle()
+{
+	BuildingGameObj* refinery = Find_Building(BuildingConstants::TYPE_REFINERY);
+	return refinery ? refinery->As_RefineryGameObj()->Get_Harvester_Vehicle() : nullptr;
+}
 void BaseControllerClass::Set_Can_Generate_Soldiers(bool CanGenerate)
 {
 	CanGenerateSoldiers = CanGenerate;
@@ -294,6 +296,26 @@
 	return 0;
 }
 
+void RefineryGameObj::Destroy_Harvester()
+{
+	if (Get_Harvester_Vehicle())
+	{
+		Commands->Apply_Damage(Get_Harvester_Vehicle(),99999,"Death",0);
+	}
+}
+
+VehicleGameObj *
+RefineryGameObj::Get_Harvester_Vehicle (void)
+{
+	VehicleGameObj *vehicle = NULL;
+
+	if (Harvester != NULL) {
+		vehicle = Harvester->Get_Vehicle ();
+	}
+
+	return vehicle;
+}
+
 GameObject SCRIPTS_API *Find_Harvester(int team)
 {
 	BaseControllerClass *c = BaseControllerClass::Find_Base(team);
diff -uwr source/scripts/engine_game.h 4.0/source/scripts/engine_game.h
--- source/scripts/engine_game.h	2011-04-27 12:07:22.000000000 +0800
+++ 4.0/source/scripts/engine_game.h	2011-10-11 21:54:02.241210900 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Global ingame classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_io.cpp 4.0/source/scripts/engine_io.cpp
--- source/scripts/engine_io.cpp	2011-09-04 18:16:04.000000000 +0800
+++ 4.0/source/scripts/engine_io.cpp	2011-10-13 01:39:18.449218700 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	File Input/Output related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -46,19 +45,23 @@
 {
 	_TheFileFactory->Return_File(file);
 }
+char FilePath[MAX_PATH];
+char AppDataPath[MAX_PATH];
+char RegPath[MAX_PATH];
+bool PathsInit = false;
+void Read_Paths()
+{
+	const bool isClient = (Exe == 0);
+
 char RegBase[MAX_PATH];
 char RegClient[MAX_PATH];
 char RegFDS[MAX_PATH];
 char FileBase[MAX_PATH];
 char FileClient[MAX_PATH];
 char FileFDS[MAX_PATH];
-char FilePath[MAX_PATH];
-char RegPath[MAX_PATH];
-bool PathsInit = false;
-void Read_Paths()
-{
+
 	PathsInit = true;
-	bool UseRenFolder = (!Exe) ? false : true;
+	bool UseRenFolder = !isClient;
 	INIClass *ini = Get_INI("paths.ini");
 	if (ini)
 	{
@@ -67,15 +70,8 @@
 		ini->Get_String("paths","RegFDS","RenegadeFDS",RegFDS,MAX_PATH);
 		ini->Get_String("paths","FileBase","Renegade",FileBase,MAX_PATH);
 		ini->Get_String("paths","FileClient","Client",FileClient,MAX_PATH);
-		ini->Get_String("paths","FileFDS","FDS",FileFDS,MAX_PATH);
-		if (!Exe)
-		{
-			UseRenFolder = ini->Get_Bool("paths","UseRenFolder",false);
-		}
-		else
-		{
-			UseRenFolder = ini->Get_Bool("paths","UseRenFolder",true);
-		}
+		ini->Get_String("paths","","FDS",FileFDS,MAX_PATH);
+		UseRenFolder = ini->Get_Bool("paths","UseRenFolder",UseRenFolder);
 		Release_INI(ini);
 	}
 	else
@@ -120,26 +116,49 @@
 	strcat(FilePath,"\\");
 	strcat(FilePath,FileBase);
 	strcat(FilePath,"\\");
-	if (!Exe)
+	strcat(FilePath,isClient ? FileClient : FileFDS);
+	strcat(FilePath,"\\");
+
+	AppDataPath[0] = 0;
+	if (!UseRenFolder)
+	{
+		wchar_t fpath[MAX_PATH];
+		SHGetSpecialFolderPathW(NULL, fpath, CSIDL_MYDOCUMENTS, FALSE);
+		bool unicode = false;
+		for (int i = 0;fpath[i] != 0;i++)
 	{
-		strcat(FilePath,FileClient);
+			unsigned short value = fpath[i];
+			if (value > 255)
+			{
+				unicode = true;
+				break;
 	}
-	else
+		}
+		if (unicode)
 	{
-		strcat(FilePath,FileFDS);
+			GetModuleFileName(NULL,AppDataPath,MAX_PATH);
+			strrchr(AppDataPath,'\\')[0] = 0;
 	}
-	strcat(FilePath,"\\");
-	strcpy(RegPath,"Software\\");
-	strcat(RegPath,RegBase);
-	strcat(RegPath,"\\");
-	if (!Exe)
+		else
 	{
-		strcat(RegPath,RegClient);
+			SHGetSpecialFolderPath(NULL, AppDataPath, CSIDL_APPDATA, FALSE);
+		}
 	}
 	else
 	{
-		strcat(RegPath,RegFDS);
+		GetModuleFileName(NULL,AppDataPath,MAX_PATH);
+		strrchr(AppDataPath,'\\')[0] = 0;
 	}
+	strcat(AppDataPath,"\\");
+	strcat(AppDataPath,FileBase);
+	strcat(AppDataPath,"\\");
+	strcat(AppDataPath,isClient ? FileClient : FileFDS);
+	strcat(AppDataPath,"\\");
+
+	strcpy(RegPath,"Software\\");
+	strcat(RegPath,RegBase);
+	strcat(RegPath,"\\");
+	strcat(RegPath,isClient ? RegClient : RegFDS);
 }
 const char SCRIPTS_API *Get_File_Path()
 {
@@ -149,6 +168,14 @@
 	}
 	return FilePath;
 }
+const char SCRIPTS_API *Get_App_Data_Path()
+{
+	if (!PathsInit)
+	{
+		Read_Paths();
+	}
+	return AppDataPath;
+}
 const char SCRIPTS_API *Get_Registry_Path()
 {
 	if (!PathsInit)
diff -uwr source/scripts/engine_io.h 4.0/source/scripts/engine_io.h
--- source/scripts/engine_io.h	2011-08-25 15:49:48.000000000 +0800
+++ 4.0/source/scripts/engine_io.h	2011-10-12 09:16:50.970703100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	File Input/Output related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -197,12 +196,15 @@
 unsigned int SCRIPTS_API Get_Registry_Int(const char *entry,int defaultvalue); //Get an int value from the renegade registry key
 #ifndef TTLE_EXPORTS
 #ifndef WWCONFIG
+#ifndef PACKAGEEDITOR
 #ifndef EXTERNAL
 extern SCRIPTS_API REF_DECL2(_TheFileFactory, FileFactoryClass*);
 #endif
 #endif
 #endif
+#endif
 const char SCRIPTS_API *Get_File_Path();
+const char SCRIPTS_API *Get_App_Data_Path();
 const char SCRIPTS_API *Get_Registry_Path();
 void SCRIPTS_API Strip_Path_From_Filename(StringClass& target, const char* fileName);
 #endif
diff -uwr source/scripts/engine_math.cpp 4.0/source/scripts/engine_math.cpp
--- source/scripts/engine_math.cpp	2011-08-20 10:06:48.000000000 +0800
+++ 4.0/source/scripts/engine_math.cpp	2011-10-11 23:03:26.540039000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Math related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_math.h 4.0/source/scripts/engine_math.h
--- source/scripts/engine_math.h	2011-08-20 10:06:48.000000000 +0800
+++ 4.0/source/scripts/engine_math.h	2011-10-11 21:55:04.250976500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Math related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_obj.cpp 4.0/source/scripts/engine_obj.cpp
--- source/scripts/engine_obj.cpp	2011-09-04 13:49:10.000000000 +0800
+++ 4.0/source/scripts/engine_obj.cpp	2011-10-14 22:25:11.520507800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	GameObject classes and related engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -27,6 +26,113 @@
 #include "SmartGameObjDef.h"
 #include "VehicleFactoryGameObj.h"
 #include "VehicleFactoryGameObjDef.h"
+#include "TransitionGameObjDef.h"
+#include "AirFactoryGameObjDef.h"
+#include "AirFactoryGameObj.h"
+#include "AirStripGameObjDef.h"
+#include "AirStripGameObj.h"
+#include "BeaconGameObjDef.h"
+#include "BeaconGameObj.h"
+#include "C4GameObjDef.h"
+#include "C4GameObj.h"
+#include "CinematicGameObjDef.h"
+#include "CinematicGameObj.h"
+#include "ComCenterGameObjDef.h"
+#include "ComCenterGameObj.h"
+#include "ConstructionYardGameObjDef.h"
+#include "ConstructionYardGameObj.h"
+#include "DamageZoneGameObjDef.h"
+#include "DamageZoneGameObj.h"
+#include "PowerPlantGameObjDef.h"
+#include "PowerPlantGameObj.h"
+#include "RepairBayGameObjDef.h"
+#include "RepairBayGameObj.h"
+#include "SamSiteGameObjDef.h"
+#include "SamSiteGameObj.h"
+#include "SoldierFactoryGameObjDef.h"
+#include "SoldierFactoryGameObj.h"
+#include "SpecialEffectsGameObjDef.h"
+#include "SpecialEffectsGameObj.h"
+#include "TransitionGameObjDef.h"
+#include "TransitionGameObj.h"
+#include "WarFactoryGameObjDef.h"
+#include "WarFactoryGameObj.h"
+
+const AirFactoryGameObjDef &
+AirFactoryGameObj::Get_Definition (void) const
+{
+	return (const AirFactoryGameObjDef &)BaseGameObj::Get_Definition ();
+}
+const AirStripGameObjDef & AirStripGameObj::Get_Definition( void ) const
+{
+	return (const AirStripGameObjDef &)BaseGameObj::Get_Definition();
+}
+const ArmedGameObjDef & ArmedGameObj::Get_Definition( void ) const
+{
+	return (const ArmedGameObjDef &)BaseGameObj::Get_Definition();
+}
+const BeaconGameObjDef & BeaconGameObj::Get_Definition( void ) const
+{
+	return (const BeaconGameObjDef &)BaseGameObj::Get_Definition();
+}
+const C4GameObjDef & C4GameObj::Get_Definition( void ) const
+{
+	return (const C4GameObjDef &)BaseGameObj::Get_Definition();
+}
+const CinematicGameObjDef & CinematicGameObj::Get_Definition( void ) const
+{
+	return (const CinematicGameObjDef &)BaseGameObj::Get_Definition();
+}
+const ComCenterGameObjDef &
+ComCenterGameObj::Get_Definition (void) const
+{
+	return (const ComCenterGameObjDef &)BaseGameObj::Get_Definition ();
+}
+const ConstructionYardGameObjDef &
+ConstructionYardGameObj::Get_Definition (void) const
+{
+	return (const ConstructionYardGameObjDef &)BaseGameObj::Get_Definition ();
+}
+const DamageZoneGameObjDef & DamageZoneGameObj::Get_Definition( void ) const
+{
+	return (const DamageZoneGameObjDef &)BaseGameObj::Get_Definition();
+}
+const PowerPlantGameObjDef &
+PowerPlantGameObj::Get_Definition (void) const
+{
+	return (const PowerPlantGameObjDef &)BaseGameObj::Get_Definition ();
+}
+const RepairBayGameObjDef &
+RepairBayGameObj::Get_Definition (void) const
+{
+	return (const RepairBayGameObjDef &)BaseGameObj::Get_Definition ();
+}
+const SamSiteGameObjDef & SamSiteGameObj::Get_Definition( void ) const
+{
+	return (const SamSiteGameObjDef &)BaseGameObj::Get_Definition();
+}
+const SoldierGameObjDef & SoldierGameObj::Get_Definition( void ) const
+{
+	return (const SoldierGameObjDef &)BaseGameObj::Get_Definition();
+}
+const SoldierFactoryGameObjDef &
+SoldierFactoryGameObj::Get_Definition (void) const
+{
+	return (const SoldierFactoryGameObjDef &)BaseGameObj::Get_Definition ();
+}
+const SpecialEffectsGameObjDef & SpecialEffectsGameObj::Get_Definition( void ) const
+{
+	return (const SpecialEffectsGameObjDef &)BaseGameObj::Get_Definition();
+}
+const TransitionGameObjDef & TransitionGameObj::Get_Definition( void ) const
+{
+	return (const TransitionGameObjDef &)BaseGameObj::Get_Definition();
+}
+const WarFactoryGameObjDef &
+WarFactoryGameObj::Get_Definition (void) const
+{
+	return (const WarFactoryGameObjDef &)BaseGameObj::Get_Definition ();
+}
 
 const VehicleFactoryGameObjDef &
 VehicleFactoryGameObj::Get_Definition (void) const
@@ -1310,7 +1416,7 @@
 }
 
 
-GameObject SCRIPTS_API *Get_Closest_Armed_Object_To_Object( GameObject* obj, int team = 2 )
+GameObject SCRIPTS_API *Get_Closest_Armed_Object_To_Object( GameObject* obj, int team )
 {
 	float closestdist = FLT_MAX;
 	GameObject *closest = 0;
@@ -1358,23 +1464,23 @@
 
 
 
-RENEGADE_FUNCTION
 void PhysicalGameObj::Set_Transform(const Matrix3D& mat)
-AT2(0x006A5EF0,0x006A5790);
-
-
+{
+	PhysObj->Set_Transform(mat);
+}
 
-RENEGADE_FUNCTION
 const Matrix3D &PhysicalGameObj::Get_Transform() const
-AT2(0x006A5F10,0x006A57B0);
-
-
+{
+	return PhysObj->Get_Transform();
+}
 
-RENEGADE_FUNCTION
 void PhysicalGameObj::Set_Position(const Vector3& position)
-AT2(0x006A5F50, 0x006A57F0);
-
-
+{
+	const Matrix3D &mat = PhysObj->Get_Transform();
+	Matrix3D tm = mat;
+	tm.Set_Translation(position);
+	PhysObj->Set_Transform(tm);
+}
 
 RENEGADE_FUNCTION
 void PhysicalGameObj::Post_Think()
@@ -1387,7 +1493,7 @@
 	return ((p_obj == this) || (Is_Team_Player() && Get_Player_Type() == p_obj->Get_Player_Type()));
 }
 
-int VehicleGameObj::Get_Occupant_Count(void)
+int SCRIPTS_API VehicleGameObj::Get_Occupant_Count(void)
 {
 	int count = 0;
 	for ( int i = 0; i < SeatOccupants.Length(); i++ ) {
@@ -1398,9 +1504,21 @@
 	return count;
 }
 
-RENEGADE_FUNCTION
 VehicleGameObj* SoldierGameObj::Get_Profile_Vehicle( void )
-AT2(0x006CE640,0x006CDEE0)
+{
+	if (( Get_State() == HumanStateClass::IN_VEHICLE ) && Vehicle )
+	{
+		return Vehicle;
+	}
+	if (( Get_State() == HumanStateClass::TRANSITION ) && ( TransitionCompletionData != NULL ))
+	{
+		if ( TransitionCompletionData->Type == TransitionDataClass::VEHICLE_ENTER )
+		{
+			return (VehicleGameObj *)TransitionCompletionData->Vehicle.Get_Ptr();
+		}
+	}
+	return NULL;
+}
 
 bool DamageableGameObj::Is_Team_Player(void) 
 {
diff -uwr source/scripts/engine_obj.h 4.0/source/scripts/engine_obj.h
--- source/scripts/engine_obj.h	2011-08-20 09:50:42.000000000 +0800
+++ 4.0/source/scripts/engine_obj.h	2011-10-11 21:54:59.320312500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	GameObject classes and related engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_obj2.cpp 4.0/source/scripts/engine_obj2.cpp
--- source/scripts/engine_obj2.cpp	2011-08-12 06:39:28.000000000 +0800
+++ 4.0/source/scripts/engine_obj2.cpp	2011-10-22 13:31:31.273437500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Soldier, Vehicle and Script Zone related engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, Joshua "NeoSaber" Kraft
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -12,6 +11,7 @@
 */
 #include "general.h"
 #include "SoldierGameObj.h"
+#include "SoldierGameObjDef.h"
 #include "VehicleGameObj.h"
 #include "VehicleGameObjDef.h"
 #include "VehicleFactoryGameObj.h"
@@ -23,6 +23,9 @@
 #include "engine_def.h"
 #include "CollisionMath.h"
 #include "PhysicsSceneClass.h"
+#include "AirFactoryGameObj.h"
+#include "AirFactoryGameObjDef.h"
+#include "VehicleFactoryGameObjDef.h"
 
 RENEGADE_FUNCTION
 GameObject *Create_Library_Object(const char *preset)
@@ -32,6 +35,15 @@
 void SoldierGameObj::Toggle_Fly_Mode()
 AT2(0x006CFC80,0x006CF520);
 RENEGADE_FUNCTION
+void AirFactoryGameObj::Create_Vehicle(int defintion_id,SoldierGameObj * player)
+AT2(0x006EDC80,0x006ED240);
+RENEGADE_FUNCTION
+int AirFactoryGameObj::Get_Team_Vehicle_Count() const
+AT2(0x006F16B0,0x006F0C70);
+RENEGADE_FUNCTION
+bool AirFactoryGameObj::Is_Available_For_Purchase() const
+AT2(0x0070B6F0,0x0070ACB0);
+RENEGADE_FUNCTION
 bool VehicleFactoryGameObj::Request_Vehicle(int defintion_id, float generation_time,SoldierGameObj * player)
 AT2(0x006EE1A0,0x006ED760);
 RENEGADE_FUNCTION
@@ -124,16 +136,6 @@
 	}
 }
 
-void SCRIPTS_API Soldier_Re_Init(GameObject *obj,DefinitionClass *def)
-{
-	if (!obj || !Commands->Get_ID(obj))
-	{
-		return;
-	}
-	SoldierGameObj *o = (SoldierGameObj *)As_SoldierGameObj(obj);
-	o->Re_Init(*(const SoldierGameObjDef *)def);
-}
-
 bool SCRIPTS_API Change_Character(GameObject *obj,const char *Preset_Name)
 {
 	if (!Commands->Get_ID(obj) || !obj || Get_Vehicle(obj))
@@ -149,43 +151,29 @@
 	{
 		return false;
 	}
-	GameObject *o = As_SoldierGameObj(obj);
+	SoldierGameObj *o = obj->As_SoldierGameObj();
 	if (!o)
 	{
 		return false;
 	}
-	Soldier_Re_Init(o,def);
-	((ScriptableGameObj *)obj)->Post_Re_Init();
+	o->Re_Init(*(SoldierGameObjDef *)def);
+	o->Post_Re_Init();
 	return true;
 }
 
-bool SCRIPTS_API IsAvailableForPurchase(GameObject *factory)
-{
-	return ((VehicleFactoryGameObj *)factory)->Is_Available_For_Purchase();
-}
-
-void SCRIPTS_API Create_Vehicle(const char *Preset_Name,float Delay,GameObject *Owner,int Team)
+bool SCRIPTS_API Is_Available_For_Purchase(GameObject *factory)
 {
-	GameObject *o = 0;
-	if (Owner)
+	if (factory->As_BuildingGameObj() && factory->As_BuildingGameObj()->As_VehicleFactoryGameObj())
 	{
-		o = As_SoldierGameObj(Owner);
+		return factory->As_BuildingGameObj()->As_VehicleFactoryGameObj()->Is_Available_For_Purchase();
 	}
-	DefinitionClass *def = Find_Named_Definition(Preset_Name);
-	if (def)
-	{
-		if (!Get_Vehicle(o))
+	else if (factory->As_BuildingGameObj() && factory->As_BuildingGameObj()->As_AirFactoryGameObj())
 		{
-			GameObject *factory = Find_Vehicle_Factory(Team);
-			if (factory)
-			{
-				if (IsAvailableForPurchase(factory))
-				{
-					unsigned int ID = def->Get_ID();
-					((VehicleFactoryGameObj *)factory)->Request_Vehicle(ID,Delay,(SoldierGameObj *)o);
-				}
-			}
+		return factory->As_BuildingGameObj()->As_AirFactoryGameObj()->Is_Available_For_Purchase();
 		}
+	else
+	{
+		return false;
 	}
 }
 
@@ -409,16 +397,6 @@
 	return (Get_Vehicle_Mode(obj) == VEHICLE_TYPE_FLYING) || Get_Fly_Mode(obj);
 }
 
-int SCRIPTS_API Get_Team_Vehicle_Count(int team)
-{
-	VehicleFactoryGameObj *o = (VehicleFactoryGameObj *)Find_Vehicle_Factory(team);
-	if (!o)
-	{
-		return 0;
-	}
-	return o->Get_Team_Vehicle_Count();
-}
-
 GameObject SCRIPTS_API *Get_Vehicle_Owner(GameObject *obj)
 {	
 	if (!obj || !Commands->Get_ID(obj))
@@ -677,4 +655,9 @@
 	return (const SmartGameObjDef &)BaseGameObj::Get_Definition();
 }
 
+bool SCRIPTS_API ActionClass::Is_Acting( void )
+{
+	return ( ActionCode != NULL );
+}
+
 REF_DEF2(SmartGameObj::GlobalSightRangeScale,float,0x00811E64,0x0081103C);
diff -uwr source/scripts/engine_obj2.h 4.0/source/scripts/engine_obj2.h
--- source/scripts/engine_obj2.h	2010-05-31 12:52:02.000000000 +0800
+++ 4.0/source/scripts/engine_obj2.h	2011-10-20 22:21:42.989257800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Soldier, Vehicle and Script Zone related engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, Joshua "NeoSaber" Kraft
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -17,7 +16,7 @@
 GameObject SCRIPTS_API *Get_Vehicle(GameObject *obj); //gets the vechicle that obj is driving
 void SCRIPTS_API Grant_Refill(GameObject *obj); //triggers the same code as the refill button on the PT
 bool SCRIPTS_API Change_Character(GameObject *obj,const char *Preset_Name); //will change the character of the passed in object to the passed in preset
-void SCRIPTS_API Create_Vehicle(const char *Preset_Name,float Delay,GameObject *Owner,int Team); //creates a vechicle,dont know what Delay is for,Owner is for the owner of the vechicle,Team says which sides factories to create it at
+bool SCRIPTS_API Create_Vehicle(const char *Preset_Name,float Delay,GameObject *Owner,int Team); //creates a vechicle,dont know what Delay is for,Owner is for the owner of the vechicle,Team says which sides factories to create it at
 void SCRIPTS_API Toggle_Fly_Mode(GameObject *obj); //makes a soldier fly if they arent flying or not fly if they are
 int SCRIPTS_API Get_Vehicle_Occupant_Count(GameObject *obj); //gets the count of occupants in a vehicle
 //these next 3 may return NULL (e.g. if no-one is in the seat or if its not a vehicle)
@@ -33,7 +32,6 @@
 void SCRIPTS_API Soldier_Transition_Vehicle(GameObject *obj); //makes the soldier exit the vehicle they are in (or if right next to a vehicle, get in)
 unsigned int SCRIPTS_API Get_Vehicle_Mode(GameObject *obj); //Gets the mode of a vehicle
 bool SCRIPTS_API Is_VTOL(GameObject *obj); //is this something that should be targeted as a VTOL
-int SCRIPTS_API Get_Team_Vehicle_Count(int team); //Gets the current vehicle count for a team
 GameObject SCRIPTS_API *Get_Vehicle_Owner(GameObject *obj); //Gets the owner (if any) of a vehicle. Will not work if used within the first second after the ::Created event is called
 void SCRIPTS_API Force_Occupants_Exit_Team(GameObject *obj,int team); //kick all occupants not of a given team out of the vehicle
 unsigned int SCRIPTS_API Get_Vehicle_Definition_Mode(const char *preset); //get the mode of a vehicle given its preset name
@@ -45,7 +43,7 @@
 void SCRIPTS_API Set_Zone_Box(GameObject *obj,OBBoxClass &box); //Set the box (size/position) of a ScriptZoneGameObj
 GameObject SCRIPTS_API *Create_Zone(const char *preset,OBBoxClass &box); //Create a script zone and set its box
 bool SCRIPTS_API PointInZone(GameObject *obj,const Vector3 &v); //Is a point in a zone
-bool SCRIPTS_API IsAvailableForPurchase(GameObject *factory); //Is it possible to purchase a vehicle from this factory
+bool SCRIPTS_API Is_Available_For_Purchase(GameObject *factory); //Is it possible to purchase a vehicle from this factory
 GameObject SCRIPTS_API *Get_Vehicle_Gunner_Pos(GameObject *obj); //Get the vehicle gunner, returns zero if there is no gunner
 void SCRIPTS_API Set_Vehicle_Is_Visible(GameObject *obj,bool visible); //works like Set_Is_Visible but for vehicles, makes them be ignored by Enemy_Seen
 void SCRIPTS_API Set_Vehicle_Gunner(GameObject *obj,int seat); //set gunner for this vehicle
diff -uwr source/scripts/engine_phys.cpp 4.0/source/scripts/engine_phys.cpp
--- source/scripts/engine_phys.cpp	2011-08-12 06:39:28.000000000 +0800
+++ 4.0/source/scripts/engine_phys.cpp	2011-10-22 20:22:09.932617100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Physics,3d geometry and animation related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -24,6 +23,7 @@
 #include "GameObjManager.h"
 #include "engine_obj2.h"
 #include "SmartGameObj.h"
+#include "VehicleGameObj.h"
 const char SCRIPTS_API *Get_Model(GameObject *obj)
 {
 	if (!obj || !Commands->Get_ID(obj))
@@ -655,7 +655,8 @@
 				if ((Get_Object_Type(obj) == team) || (team == 2))
 				{
 					bool stealth = Is_Stealth(obj);
-					if (stealth)
+					bool underground = obj->As_VehicleGameObj()->Is_Underground();
+					if (stealth || underground)
 					{
 						ObjPosition = Commands->Get_Position(obj);
 						ObjPosition.X += offset.X;
diff -uwr source/scripts/engine_phys.h 4.0/source/scripts/engine_phys.h
--- source/scripts/engine_phys.h	2010-05-31 13:00:46.000000000 +0800
+++ 4.0/source/scripts/engine_phys.h	2011-10-11 21:53:38.783203100 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Physics,3d geometry and animation related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_player.cpp 4.0/source/scripts/engine_player.cpp
--- source/scripts/engine_player.cpp	2011-09-03 08:29:42.000000000 +0800
+++ 4.0/source/scripts/engine_player.cpp	2011-10-11 23:03:20.238281200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Team and player data related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -26,9 +25,11 @@
 RENEGADE_FUNCTION
 int SCRIPTS_API Get_Player_Count()
 AT2(0x00417040,0x00417040);
+#ifndef TT_EXPORTS
 RENEGADE_FUNCTION
-void cPlayer::Set_Player_Type(int type)
+void SCRIPTS_API cPlayer::Set_Player_Type(int type)
 AT2(0x0040D600,0x0040D600);
+#endif
 RENEGADE_FUNCTION
 void cPlayer::Set_Ladder_Points(int amount)
 AT2(0x0040FC90,0x0040FC90);
diff -uwr source/scripts/engine_player.h 4.0/source/scripts/engine_player.h
--- source/scripts/engine_player.h	2011-09-03 08:29:40.000000000 +0800
+++ 4.0/source/scripts/engine_player.h	2011-10-11 21:54:40.969726500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Team and player data related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_pt.cpp 4.0/source/scripts/engine_pt.cpp
--- source/scripts/engine_pt.cpp	2010-08-19 18:54:10.000000000 +0800
+++ 4.0/source/scripts/engine_pt.cpp	2011-10-11 23:03:18.812500000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Weapon related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_pt.h 4.0/source/scripts/engine_pt.h
--- source/scripts/engine_pt.h	2010-05-31 12:58:36.000000000 +0800
+++ 4.0/source/scripts/engine_pt.h	2011-10-11 21:53:31.451171800 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Classes and engine calls related to what can be bought from the PT/sidebar
-	Copyright 2010 Jonathan Wilson, Mark Sararu, WhiteDragon(MDB)
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_script.cpp 4.0/source/scripts/engine_script.cpp
--- source/scripts/engine_script.cpp	2011-08-12 06:39:26.000000000 +0800
+++ 4.0/source/scripts/engine_script.cpp	2011-10-11 23:03:17.410156200 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Script manipulation related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_script.h 4.0/source/scripts/engine_script.h
--- source/scripts/engine_script.h	2011-03-15 13:53:18.000000000 +0800
+++ 4.0/source/scripts/engine_script.h	2011-10-11 21:53:56.809570300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Script manipulation related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_string.cpp 4.0/source/scripts/engine_string.cpp
--- source/scripts/engine_string.cpp	2010-12-11 12:22:10.000000000 +0800
+++ 4.0/source/scripts/engine_string.cpp	2011-10-11 23:03:15.960937500 +0800
@@ -1,6 +1,5 @@
 /* Renegade Scripts.dll
-	String related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_string.h 4.0/source/scripts/engine_string.h
--- source/scripts/engine_string.h	2010-12-06 07:57:18.000000000 +0800
+++ 4.0/source/scripts/engine_string.h	2011-10-11 21:53:52.137695300 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	String related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_tdb.cpp 4.0/source/scripts/engine_tdb.cpp
--- source/scripts/engine_tdb.cpp	2011-08-12 06:39:24.000000000 +0800
+++ 4.0/source/scripts/engine_tdb.cpp	2011-10-11 23:03:14.446289000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Classes and engine calls that deal with strings.tdb
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -111,7 +110,7 @@
 		return newstr("");
 	}
 	WeaponBagClass *w = ((ArmedGameObj *)o)->Get_Weapon_Bag();
-	if (w->Peek_Weapon(position))
+	if ((position) && (position < w->Get_Count()))
 	{
 		return Get_Translated_String(w->Peek_Weapon(position)->Get_Definition()->IconNameID);
 	}
diff -uwr source/scripts/engine_tdb.h 4.0/source/scripts/engine_tdb.h
--- source/scripts/engine_tdb.h	2010-05-31 13:16:46.000000000 +0800
+++ 4.0/source/scripts/engine_tdb.h	2011-10-11 21:53:48.353515600 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Classes and engine calls that deal with strings.tdb
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_threading.cpp 4.0/source/scripts/engine_threading.cpp
--- source/scripts/engine_threading.cpp	2010-04-14 10:13:12.000000000 +0800
+++ 4.0/source/scripts/engine_threading.cpp	2011-10-11 23:03:12.640625000 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Threading related Engine Calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
diff -uwr source/scripts/engine_threading.h 4.0/source/scripts/engine_threading.h
--- source/scripts/engine_threading.h	2010-04-14 10:13:16.000000000 +0800
+++ 4.0/source/scripts/engine_threading.h	2011-10-11 21:53:44.601562500 +0800
@@ -1,6 +1,5 @@
 /*	Renegade Scripts.dll
-	Threading related classes and engine calls
-	Copyright 2010 Jonathan Wilson, Mark Sararu
+	Copyright 2011 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
